var lWarn = {
	logln : function(o) {
	}
};
var lInfo = {
	logln : function(o) {
	}
};

var LOGFILE_NAME = "upnp-controller.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);


function makeHTTPGet(URL) {
    var extraheaders = [];
    var options;
    lInfo.logln("http get reuqest " + URL);
    try {
        if (options==null)
            options= { 'debug' : 0};
        else
            options.debug=0;
        var h = new HTTP(options);
        var code = h.get(URL, '');
        if (code.status.valueOf() === 200) {
            lInfo.logln( ': OK [' + code.status + ']');
        } else {
            lInfo.logln(': FAILED! Server replied: "' + code.status + '"');
        }
        lInfo.logln(code.body);
        return (code.body);
    } catch (e) {
        lWarn.logln("Error during upload: ");
        for (var i in e) {
            lWarn.logln(i + ': ' + e[i]);
        }
    }
	return null;
}

function getServices(URL) {
	var sBaseURL=URL;
	var sDescription=makeHTTPGet(URL);
	
	if (sDescription.indexOf('urn:schemas-upnp-org:service:RenderingControl:1')==-1)
		return null;
	
	var sDescription2=sDescription.substr(sDescription.indexOf('urn:schemas-upnp-org:service:RenderingControl:1'));
	sDescription2=sDescription2.substr(sDescription2.indexOf('<controlURL>'));
	var sControlUrl=sDescription2.substr(12,sDescription2.indexOf('</controlURL>')-12);
	lInfo.logln('ControlURL: ' + sControlUrl);
	
	sDescription2=sDescription.substr(sDescription.indexOf('urn:schemas-upnp-org:service:AVTransport:1'));
	sDescription2=sDescription2.substr(sDescription2.indexOf('<controlURL>'));
	var sAVTransportURL=sDescription2.substr(12,sDescription2.indexOf('</controlURL>')-12);
	lInfo.logln('AV Transport: ' + sAVTransportURL);
	
	return {controlURL:sControlUrl,transportURL:sAVTransportURL};
	
}

function storeSubParameter(root, path, value) {
	Property.setProperty(root + '/' + path, value);
	Property.setFlag(root + '/' + path, 'ARCHIVE', true);
	lInfo.logln("STORING " + root + "/" + path + " -> " + value);
}

/** 
@brief Creates new ID required for storing to PropertyTree for room modes

@param -
 
@return New ID value
*/
function getNewIdValue(sNode) {
   var idValue = 0;
   var baseNode = Property.getNode(sNode);
   if (baseNode == null)
       return idValue;
   var oArrayNode = baseNode.getChildren();
   if (oArrayNode != null) {
     for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
         var oChildNode = oArrayNode[iIndex];
         if (oChildNode.getChild('id') != null) {
             if (oChildNode.getChild('id').getValue() != null)
                 if (parseInt("" + oChildNode.getChild('id').getValue(),10) >= idValue)
                     idValue = parseInt("" + oChildNode.getChild('id').getValue(),10) + 1;
         }
     }
   }
   return idValue;
}



if (raisedEvent.name=='upnp-controller.generic') {
	if (raisedEvent.parameter.actions=='updateRaumfeld') {
		checkRaumfeld();
	}
	if (raisedEvent.parameter.actions=='urlsearch') {
		if (raisedEvent.parameter.url!=null) {
			lInfo.logln('call urlsearch ' + raisedEvent.parameter.url);
			var oURLS=getServices(unescape(raisedEvent.parameter.url));
			if (oURLS==null) {
				lInfo.logln('device is not a renderer ' + raisedEvent.parameter.url);
				
			} else
				
			try {
				var sNewID=getNewIdValue('upnp-players');
				lInfo.logln('save getNewIdValue ' + raisedEvent.parameter.url);
				var sName;
				var zoneID;
				var ipAdress=unescape(raisedEvent.parameter.url);
				if (ipAdress.indexOf('//')>=0)
					ipAdress=ipAdress.substr(ipAdress.indexOf('//')+2);
				ipAdress=ipAdress.substr(0,ipAdress.indexOf(':'));
				var port=unescape(raisedEvent.parameter.url);
				port=port.substr(port.indexOf(':')+1);
				port=port.substr(port.indexOf(':')+1);
				port=port.substr(0,port.indexOf('/'));
				var typeID='generic';
				var avControlURL=oURLS.transportURL;
				var renderURL=oURLS.controlURL;
				if (raisedEvent.parameter.dsid==null) {
					sName='Manually searched';
					zoneID=0;
					storeSubParameter('upnp-players' + '/' + sNewID,'dsid',"0");
				} else
				if (raisedEvent.parameter.dsid==0) {
					sName='Manually searched';
					zoneID=0;
					storeSubParameter('upnp-players' + '/' + sNewID,'dsid',"0");
				} else {
					sName=getDevices().byDSID(raisedEvent.parameter.dsid).name;
					if (sName=='')
						sName='(' + raisedEvent.parameter.dsid+ ')';
					zoneID=getDevices().byDSID(raisedEvent.parameter.dsid).zoneID;
					storeSubParameter('upnp-players' + '/' + sNewID,'dsid',raisedEvent.parameter.dsid);
				}			
				lInfo.logln('save getNewIdValue ' + raisedEvent.parameter.url);
				storeSubParameter('upnp-players' + '/' + sNewID,'id',sNewID);
				storeSubParameter('upnp-players' + '/' + sNewID,'name',sName);
				storeSubParameter('upnp-players' + '/' + sNewID,'roomID',zoneID);
				storeSubParameter('upnp-players' + '/' + sNewID,'ipAddress',ipAdress);
				storeSubParameter('upnp-players' + '/' + sNewID,'port',port);
				storeSubParameter('upnp-players' + '/' + sNewID,'typeID',typeID);
				storeSubParameter('upnp-players' + '/' + sNewID,'avControlURL',avControlURL);
				storeSubParameter('upnp-players' + '/' + sNewID,'renderURL',renderURL);
				Property.store();
			} catch (e) {
				lWarn.logln(' error ' + e);
			}
		}	
	}
	if (raisedEvent.parameter.actions=='initializeDevice') {
		if (raisedEvent.parameter.dsid!=null) {
			lInfo.logln('initializeDevice with id '+ raisedEvent.parameter.dsid);
			var sURL="";
			if (raisedEvent.parameter.dsid==0) {
				sURL="http://10.10.10.128:1400/xml";
				var oNewEvent=new Event('upnp-controller.generic',{actions:'urlsearch',url:escape(sURL),dsid:raisedEvent.parameter.dsid});
				oNewEvent.raise();
			}
			else {
				try {
					sURL=getDevices().byDSID(raisedEvent.parameter.dsid).getUserProperty(0);
					lInfo.logln("URL :" + sURL);
					var oNewEvent=new Event('upnp-controller.generic',{actions:'urlsearch',url:escape(sURL),dsid:raisedEvent.parameter.dsid});
					oNewEvent.raise();
				} catch (e) {
					lWarn.logln('error by getUserProperty ' + e);
				}
			}
		}
	}
	if (raisedEvent.parameter.actions=='refreshDeviceList') {
		try {
			var oPlayerNodes=Property.getNode('upnp-players');
			var oPlayerArray=oPlayerNodes.getChildren();
			for(var iIndex=0;iIndex<oPlayerArray.length;iIndex++) {
				if (oPlayerArray[iIndex].getChild('typeID').getValue()=='generic')
					oPlayerNodes.removeChild(oPlayerArray[iIndex].getName());
			}
			lInfo.logln('start initializeDevice');
			
			var oDeviceNodes=Property.getNode('/apartment/zones/zone0/devices').getChildren();
			for (var iIndex=0;iIndex<oDeviceNodes.length;iIndex++) {
				if (oDeviceNodes[iIndex].getChild('functionID').getValue()==0x4100) {
					lInfo.logln('initializeDevice with id '+ oDeviceNodes[iIndex].getChild('dSID').getValue());
					var oNewEvent=new Event('upnp-controller.generic',{actions:'initializeDevice',dsid:oDeviceNodes[iIndex].getChild('dSID').getValue()});
					oNewEvent.raise();
				}
			}
			lInfo.logln('end initializeDevice');
		} catch (e) {
			lWarn.logln("Error " + e);
		}
	}
}

